!   C05PBA Example Program Text
!   Mark 24 Release. NAG Copyright 2012.

    Module c05pbae_mod

!     C05PBA Example Program Module:
!            Parameters and User-defined Routines

!     .. Use Statements ..
      Use nag_library, Only: nag_wp
!     .. Implicit None Statement ..
      Implicit None
!     .. Parameters ..
      Integer, Parameter                   :: n = 9, nout = 6
      Integer, Parameter                   :: ldfjac = n
    Contains
      Subroutine fcn(n,x,fvec,fjac,ldfjac,iflag,iuser,ruser)

!       .. Scalar Arguments ..
        Integer, Intent (Inout)              :: iflag
        Integer, Intent (In)                 :: ldfjac, n
!       .. Array Arguments ..
        Real (Kind=nag_wp), Intent (Inout)   :: fjac(ldfjac,n), fvec(n),       &
                                                ruser(*)
        Real (Kind=nag_wp), Intent (In)      :: x(n)
        Integer, Intent (Inout)              :: iuser(*)
!       .. Local Scalars ..
        Integer                              :: k
!       .. Executable Statements ..
        If (iflag/=2) Then
          fvec(1:n) = (ruser(2)+ruser(3)*x(1:n))*x(1:n) - ruser(5)
          fvec(2:n) = fvec(2:n) + ruser(1)*x(1:(n-1))
          fvec(1:(n-1)) = fvec(1:(n-1)) + ruser(4)*x(2:n)
        Else
          fjac(1:n,1:n) = 0.0_nag_wp

          fjac(1,1) = ruser(2) + 2.0_nag_wp*ruser(3)*x(1)
          fjac(1,2) = ruser(4)
          Do k = 2, n - 1
            fjac(k,k-1) = ruser(1)
            fjac(k,k) = ruser(2) + 2.0_nag_wp*ruser(3)*x(k)
            fjac(k,k+1) = ruser(4)
          End Do
          fjac(n,n-1) = ruser(1)
          fjac(n,n) = ruser(2) + 2.0_nag_wp*ruser(3)*x(n)

        End If

        Return

      End Subroutine fcn
    End Module c05pbae_mod
    Program c05pbae

!     C05PBA Example Main Program

!     .. Use Statements ..
      Use nag_library, Only: c05pba, dnrm2, nag_wp, x02ajf
      Use c05pbae_mod, Only: fcn, ldfjac, n, nout
!     .. Implicit None Statement ..
      Implicit None
!     .. Local Scalars ..
      Real (Kind=nag_wp)                   :: fnorm, tol
      Integer                              :: ifail, j, lwa
!     .. Local Arrays ..
      Real (Kind=nag_wp), Allocatable      :: fjac(:,:), fvec(:), x(:)
      Real (Kind=nag_wp)                   :: ruser(5), wa(1)
      Integer                              :: iuser(1)
!     .. Intrinsic Procedures ..
      Intrinsic                            :: sqrt
!     .. Executable Statements ..
      Write (nout,*) 'C05PBA Example Program Results'

      Allocate (fjac(ldfjac,n),fvec(n),x(n))

!     The following starting values provide a rough solution.

      x(1:n) = -1.0_nag_wp

!     Store the coefficients describing the system

      ruser(1:5) = (/-1.0_nag_wp,3.0_nag_wp,-2.0_nag_wp,-2.0_nag_wp, &
        -1.0_nag_wp/)

      tol = sqrt(x02ajf())

      ifail = -1
      Call c05pba(fcn,n,x,fvec,fjac,ldfjac,tol,wa,lwa,iuser,ruser,ifail)

      Select Case (ifail)
      Case (0)
!       The NAG name equivalent of dnrm2 is f06ejf
        fnorm = dnrm2(n,fvec,1)
        Write (nout,*)
        Write (nout,99999) 'Final 2-norm of the residuals =', fnorm
        Write (nout,*)
        Write (nout,*) 'Final approximate solution'
        Write (nout,*)
        Write (nout,99998)(x(j),j=1,n)
      Case (2:)
        Write (nout,*)
        Write (nout,*) 'Approximate solution'
        Write (nout,*)
        Write (nout,99998)(x(j),j=1,n)
      End Select

99999 Format (1X,A,E12.4)
99998 Format (1X,3F12.4)
    End Program c05pbae
